//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  IndianRed
#property indicator_color2  CadetBlue
#property indicator_color3  DarkGoldenrod
#property indicator_style3  STYLE_DASH

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    HalfLength      = 46;
extern int    Price           = PRICE_CLOSE;
extern int    EnvelopeShift   = 0;
extern double Deviation       = 0.63;
extern bool   ShowPriceLabels = true;
extern string UniqueID        = "TMaCenteredPrice1";
extern color  PriceColor      = PaleVioletRed;
extern int    PriceSize       = 1;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double UpEnv[];
double DnEnv[];
double tmBuf[];
double trend[];

//
//
//
//                    
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   HalfLength=MathMax(HalfLength,1);
   SetIndexBuffer(0,UpEnv); SetIndexDrawBegin(0,HalfLength); 
   SetIndexBuffer(1,DnEnv); SetIndexDrawBegin(1,HalfLength);
   SetIndexBuffer(2,tmBuf); SetIndexDrawBegin(2,HalfLength);
   SetIndexBuffer(3,trend);
   
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      SetIndexShift(0,EnvelopeShift * timeFrame/Period()); 
      SetIndexShift(1,EnvelopeShift * timeFrame/Period()); 
      SetIndexShift(2,EnvelopeShift * timeFrame/Period()); 
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+"  Tma centered envelopes ("+HalfLength+")");
   return(0);
}

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal(); i>= 0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
   }
   return (0);
}

  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars+HalfLength);
         if (returnBars)  { UpEnv[0] = limit+1; return(0); } 
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      for (i=limit; i>=0; i--)
      {
         double sum  = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double sumw = (HalfLength+1);
         for (j=1, k=HalfLength; j<=HalfLength; j++, k--)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
            sumw += k;

            if (j<=i)
            {
              sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
              sumw += k;
            }
      }
      
      tmBuf[i] = sum/sumw;
      UpEnv[i] = (1+Deviation/100)*tmBuf[i];
      DnEnv[i] = (1-Deviation/100)*tmBuf[i];
      trend[i] = trend[i+1];
         if (Close[i]>DnEnv[i]) trend[i] = 1;
         if (Close[i]<UpEnv[i]) trend[i] =-1;
      }
      
       if (ShowPriceLabels)
       {
         string  name = UniqueID+":"+"up";
          ObjectCreate(name,OBJ_ARROW,0,0,0);
             ObjectSet(name,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
             ObjectSet(name,OBJPROP_COLOR,PriceColor);
             ObjectSet(name,OBJPROP_WIDTH,PriceSize);
             ObjectSet(name,OBJPROP_PRICE1,UpEnv[0]);
             ObjectSet(name,OBJPROP_TIME1,Time[0]);
          
          name = UniqueID+":"+"lp";
          ObjectCreate(name,OBJ_ARROW,0,0,0);
             ObjectSet(name,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
             ObjectSet(name,OBJPROP_COLOR,PriceColor);
             ObjectSet(name,OBJPROP_WIDTH,PriceSize);
             ObjectSet(name,OBJPROP_PRICE1,DnEnv[0]);
             ObjectSet(name,OBJPROP_TIME1,Time[0]);
             
          name = UniqueID+":"+"mp";
          ObjectCreate(name,OBJ_ARROW,0,0,0);
             ObjectSet(name,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
             ObjectSet(name,OBJPROP_COLOR,PriceColor);
             ObjectSet(name,OBJPROP_WIDTH,PriceSize);
             ObjectSet(name,OBJPROP_PRICE1,tmBuf[0]);
             ObjectSet(name,OBJPROP_TIME1,Time[0]);
       }
     manageAlerts();    
     return(0);
     }
     
     //
     //
     //
     //
     //

     limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     for(i=limit; i>=0; i--)
     {
        int y = iBarShift(NULL,timeFrame,Time[i]);
           UpEnv[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateTma",HalfLength,Price,EnvelopeShift,Deviation,ShowPriceLabels,UniqueID,PriceColor,PriceSize,0,y);
           DnEnv[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateTma",HalfLength,Price,EnvelopeShift,Deviation,ShowPriceLabels,UniqueID,PriceColor,PriceSize,1,y);
           tmBuf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateTma",HalfLength,Price,EnvelopeShift,Deviation,ShowPriceLabels,UniqueID,PriceColor,PriceSize,2,y);
           trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateTma",HalfLength,Price,EnvelopeShift,Deviation,ShowPriceLabels,UniqueID,PriceColor,PriceSize,3,y);      
     }      
     manageAlerts();
     return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"trend");
         if (trend[whichBar] ==-1) doAlert(whichBar,"no trend");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Tma centered envelopes ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Tma centered envelopes "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

 
   

